<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>FastLeaderElection.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">FastLeaderElection.java</span></div><h1>FastLeaderElection.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package org.apache.zookeeper.server.quorum;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.TimeUnit;

import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.server.ZooKeeperThread;
import org.apache.zookeeper.server.quorum.QuorumCnxManager.Message;
import org.apache.zookeeper.server.quorum.QuorumPeer.LearnerType;
import org.apache.zookeeper.server.quorum.QuorumPeer.QuorumServer;
import org.apache.zookeeper.server.quorum.QuorumPeer.ServerState;
import org.apache.zookeeper.server.util.ZxidUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * Implementation of leader election using TCP. It uses an object of the class
 * QuorumCnxManager to manage connections. Otherwise, the algorithm is push-based
 * as with the other UDP implementations.
 *
 * There are a few parameters that can be tuned to change its behavior. First,
 * finalizeWait determines the amount of time to wait until deciding upon a leader.
 * This is part of the leader election algorithm.
 */


public class FastLeaderElection implements Election {
<span class="fc" id="L53">    private static final Logger LOG = LoggerFactory.getLogger(FastLeaderElection.class);</span>

    /**
     * Determine how much time a process has to wait
     * once it believes that it has reached the end of
     * leader election.
     */
    final static int finalizeWait = 200;


    /**
     * Upper bound on the amount of time between two consecutive
     * notification checks. This impacts the amount of time to get
     * the system up again after long partitions. Currently 60 seconds.
     */

    final static int maxNotificationInterval = 60000;

    /**
     * Connection manager. Fast leader election uses TCP for
     * communication between peers, and QuorumCnxManager manages
     * such connections.
     */

    QuorumCnxManager manager;


    /**
     * Notifications are messages that let other peers know that
     * a given peer has changed its vote, either because it has
     * joined leader election or because it learned of another
     * peer with higher zxid or same zxid and higher server id
     */

<span class="fc" id="L87">    static public class Notification {</span>
        /*
         * Format version, introduced in 3.4.6
         */
        
        public final static int CURRENTVERSION = 0x1; 
        int version;
                
        /*
         * Proposed leader
         */
        long leader;

        /*
         * zxid of the proposed leader
         */
        long zxid;

        /*
         * Epoch
         */
        long electionEpoch;

        /*
         * current state of sender
         */
        QuorumPeer.ServerState state;

        /*
         * Address of sender
         */
        long sid;

        /*
         * epoch of the proposed leader
         */
        long peerEpoch;
        
        @Override
        public String toString() {
<span class="fc" id="L127">            return new String(Long.toHexString(version) + &quot; (message format version), &quot; </span>
                    + leader + &quot; (n.leader), 0x&quot;
<span class="fc" id="L129">                    + Long.toHexString(zxid) + &quot; (n.zxid), 0x&quot;</span>
<span class="fc" id="L130">                    + Long.toHexString(electionEpoch) + &quot; (n.round), &quot; + state</span>
                    + &quot; (n.state), &quot; + sid + &quot; (n.sid), 0x&quot;
<span class="fc" id="L132">                    + Long.toHexString(peerEpoch) + &quot; (n.peerEpoch) &quot;);</span>
        }
    }
    
    static ByteBuffer buildMsg(int state,
            long leader,
            long zxid,
            long electionEpoch,
            long epoch) {
<span class="fc" id="L141">        byte requestBytes[] = new byte[40];</span>
<span class="fc" id="L142">        ByteBuffer requestBuffer = ByteBuffer.wrap(requestBytes);</span>

        /*
         * Building notification packet to send 
         */

<span class="fc" id="L148">        requestBuffer.clear();</span>
<span class="fc" id="L149">        requestBuffer.putInt(state);</span>
<span class="fc" id="L150">        requestBuffer.putLong(leader);</span>
<span class="fc" id="L151">        requestBuffer.putLong(zxid);</span>
<span class="fc" id="L152">        requestBuffer.putLong(electionEpoch);</span>
<span class="fc" id="L153">        requestBuffer.putLong(epoch);</span>
<span class="fc" id="L154">        requestBuffer.putInt(Notification.CURRENTVERSION);</span>
        
<span class="fc" id="L156">        return requestBuffer;</span>
    }

    /**
     * Messages that a peer wants to send to other peers.
     * These messages can be both Notifications and Acks
     * of reception of notification.
     */
    static public class ToSend {
<span class="pc" id="L165">        static enum mType {crequest, challenge, notification, ack}</span>

        ToSend(mType type,
                long leader,
                long zxid,
                long electionEpoch,
                ServerState state,
                long sid,
<span class="fc" id="L173">                long peerEpoch) {</span>

<span class="fc" id="L175">            this.leader = leader;</span>
<span class="fc" id="L176">            this.zxid = zxid;</span>
<span class="fc" id="L177">            this.electionEpoch = electionEpoch;</span>
<span class="fc" id="L178">            this.state = state;</span>
<span class="fc" id="L179">            this.sid = sid;</span>
<span class="fc" id="L180">            this.peerEpoch = peerEpoch;</span>
<span class="fc" id="L181">        }</span>

        /*
         * Proposed leader in the case of notification
         */
        long leader;

        /*
         * id contains the tag for acks, and zxid for notifications
         */
        long zxid;

        /*
         * Epoch
         */
        long electionEpoch;

        /*
         * Current state;
         */
        QuorumPeer.ServerState state;

        /*
         * Address of recipient
         */
        long sid;
        
        /*
         * Leader epoch
         */
        long peerEpoch;
    }

    LinkedBlockingQueue&lt;ToSend&gt; sendqueue;
    LinkedBlockingQueue&lt;Notification&gt; recvqueue;

    /**
     * Multi-threaded implementation of message handler. Messenger
     * implements two sub-classes: WorkReceiver and  WorkSender. The
     * functionality of each is obvious from the name. Each of these
     * spawns a new thread.
     */

    protected class Messenger {

        /**
         * Receives messages from instance of QuorumCnxManager on
         * method run(), and processes such messages.
         */

        class WorkerReceiver extends ZooKeeperThread {
            volatile boolean stop;
            QuorumCnxManager manager;

<span class="fc" id="L235">            WorkerReceiver(QuorumCnxManager manager) {</span>
<span class="fc" id="L236">                super(&quot;WorkerReceiver&quot;);</span>
<span class="fc" id="L237">                this.stop = false;</span>
<span class="fc" id="L238">                this.manager = manager;</span>
<span class="fc" id="L239">            }</span>

            public void run() {

                Message response;
<span class="fc bfc" id="L244" title="All 2 branches covered.">                while (!stop) {</span>
                    // Sleeps on receive
                    try{
<span class="fc" id="L247">                        response = manager.pollRecvQueue(3000, TimeUnit.MILLISECONDS);</span>
<span class="fc bfc" id="L248" title="All 2 branches covered.">                        if(response == null) continue;</span>

                        /*
                         * If it is from an observer, respond right away.
                         * Note that the following predicate assumes that
                         * if a server is not a follower, then it must be
                         * an observer. If we ever have any other type of
                         * learner in the future, we'll have to change the
                         * way we check for observers.
                         */
<span class="fc bfc" id="L258" title="All 2 branches covered.">                        if(!self.getVotingView().containsKey(response.sid)){</span>
<span class="fc" id="L259">                            Vote current = self.getCurrentVote();</span>
<span class="fc" id="L260">                            ToSend notmsg = new ToSend(ToSend.mType.notification,</span>
<span class="fc" id="L261">                                    current.getId(),</span>
<span class="fc" id="L262">                                    current.getZxid(),</span>
                                    logicalclock,
<span class="fc" id="L264">                                    self.getPeerState(),</span>
                                    response.sid,
<span class="fc" id="L266">                                    current.getPeerEpoch());</span>

<span class="fc" id="L268">                            sendqueue.offer(notmsg);</span>
<span class="fc" id="L269">                        } else {</span>
                            // Receive new message
<span class="pc bpc" id="L271" title="1 of 2 branches missed.">                            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L272">                                LOG.debug(&quot;Receive new notification message. My id = &quot;</span>
<span class="nc" id="L273">                                        + self.getId());</span>
                            }

                            /*
                             * We check for 28 bytes for backward compatibility
                             */
<span class="pc bpc" id="L279" title="1 of 2 branches missed.">                            if (response.buffer.capacity() &lt; 28) {</span>
<span class="nc" id="L280">                                LOG.error(&quot;Got a short response: &quot;</span>
<span class="nc" id="L281">                                        + response.buffer.capacity());</span>
<span class="nc" id="L282">                                continue;</span>
                            }
<span class="pc bpc" id="L284" title="1 of 2 branches missed.">                            boolean backCompatibility = (response.buffer.capacity() == 28);</span>
<span class="fc" id="L285">                            response.buffer.clear();</span>

                            // Instantiate Notification and set its attributes
<span class="fc" id="L288">                            Notification n = new Notification();</span>
                            
                            // State of peer that sent this message
<span class="fc" id="L291">                            QuorumPeer.ServerState ackstate = QuorumPeer.ServerState.LOOKING;</span>
<span class="pc bpc" id="L292" title="2 of 5 branches missed.">                            switch (response.buffer.getInt()) {</span>
                            case 0:
<span class="fc" id="L294">                                ackstate = QuorumPeer.ServerState.LOOKING;</span>
<span class="fc" id="L295">                                break;</span>
                            case 1:
<span class="fc" id="L297">                                ackstate = QuorumPeer.ServerState.FOLLOWING;</span>
<span class="fc" id="L298">                                break;</span>
                            case 2:
<span class="fc" id="L300">                                ackstate = QuorumPeer.ServerState.LEADING;</span>
<span class="fc" id="L301">                                break;</span>
                            case 3:
<span class="nc" id="L303">                                ackstate = QuorumPeer.ServerState.OBSERVING;</span>
<span class="nc" id="L304">                                break;</span>
                            default:
<span class="nc" id="L306">                                continue;</span>
                            }
                            
<span class="fc" id="L309">                            n.leader = response.buffer.getLong();</span>
<span class="fc" id="L310">                            n.zxid = response.buffer.getLong();</span>
<span class="fc" id="L311">                            n.electionEpoch = response.buffer.getLong();</span>
<span class="fc" id="L312">                            n.state = ackstate;</span>
<span class="fc" id="L313">                            n.sid = response.sid;</span>
<span class="pc bpc" id="L314" title="1 of 2 branches missed.">                            if(!backCompatibility){</span>
<span class="fc" id="L315">                                n.peerEpoch = response.buffer.getLong();</span>
                            } else {
<span class="nc bnc" id="L317" title="All 2 branches missed.">                                if(LOG.isInfoEnabled()){</span>
<span class="nc" id="L318">                                    LOG.info(&quot;Backward compatibility mode, server id=&quot; + n.sid);</span>
                                }
<span class="nc" id="L320">                                n.peerEpoch = ZxidUtils.getEpochFromZxid(n.zxid);</span>
                            }

                            /*
                             * Version added in 3.4.6
                             */

<span class="pc bpc" id="L327" title="1 of 2 branches missed.">                            n.version = (response.buffer.remaining() &gt;= 4) ? </span>
<span class="pc" id="L328">                                         response.buffer.getInt() : 0x0;</span>

                            /*
                             * Print notification info
                             */
<span class="pc bpc" id="L333" title="1 of 2 branches missed.">                            if(LOG.isInfoEnabled()){</span>
<span class="fc" id="L334">                                printNotification(n);</span>
                            }

                            /*
                             * If this server is looking, then send proposed leader
                             */

<span class="fc bfc" id="L341" title="All 2 branches covered.">                            if(self.getPeerState() == QuorumPeer.ServerState.LOOKING){</span>
<span class="fc" id="L342">                                recvqueue.offer(n);</span>

                                /*
                                 * Send a notification back if the peer that sent this
                                 * message is also looking and its logical clock is
                                 * lagging behind.
                                 */
<span class="fc bfc" id="L349" title="All 4 branches covered.">                                if((ackstate == QuorumPeer.ServerState.LOOKING)</span>
                                        &amp;&amp; (n.electionEpoch &lt; logicalclock)){
<span class="fc" id="L351">                                    Vote v = getVote();</span>
<span class="fc" id="L352">                                    ToSend notmsg = new ToSend(ToSend.mType.notification,</span>
<span class="fc" id="L353">                                            v.getId(),</span>
<span class="fc" id="L354">                                            v.getZxid(),</span>
                                            logicalclock,
<span class="fc" id="L356">                                            self.getPeerState(),</span>
                                            response.sid,
<span class="fc" id="L358">                                            v.getPeerEpoch());</span>
<span class="fc" id="L359">                                    sendqueue.offer(notmsg);</span>
<span class="fc" id="L360">                                }</span>
                            } else {
                                /*
                                 * If this server is not looking, but the one that sent the ack
                                 * is looking, then send back what it believes to be the leader.
                                 */
<span class="fc" id="L366">                                Vote current = self.getCurrentVote();</span>
<span class="fc bfc" id="L367" title="All 2 branches covered.">                                if(ackstate == QuorumPeer.ServerState.LOOKING){</span>
<span class="pc bpc" id="L368" title="1 of 2 branches missed.">                                    if(LOG.isDebugEnabled()){</span>
<span class="nc" id="L369">                                        LOG.debug(&quot;Sending new notification. My id =  &quot; +</span>
<span class="nc" id="L370">                                                self.getId() + &quot; recipient=&quot; +</span>
                                                response.sid + &quot; zxid=0x&quot; +
<span class="nc" id="L372">                                                Long.toHexString(current.getZxid()) +</span>
<span class="nc" id="L373">                                                &quot; leader=&quot; + current.getId());</span>
                                    }
                                    
                                    ToSend notmsg;
<span class="pc bpc" id="L377" title="1 of 2 branches missed.">                                    if(n.version &gt; 0x0) {</span>
<span class="fc" id="L378">                                        notmsg = new ToSend(</span>
                                                ToSend.mType.notification,
<span class="fc" id="L380">                                                current.getId(),</span>
<span class="fc" id="L381">                                                current.getZxid(),</span>
<span class="fc" id="L382">                                                current.getElectionEpoch(),</span>
<span class="fc" id="L383">                                                self.getPeerState(),</span>
                                                response.sid,
<span class="fc" id="L385">                                                current.getPeerEpoch());</span>
                                        
                                    } else {
<span class="nc" id="L388">                                        Vote bcVote = self.getBCVote();</span>
<span class="nc" id="L389">                                        notmsg = new ToSend(</span>
                                                ToSend.mType.notification,
<span class="nc" id="L391">                                                bcVote.getId(),</span>
<span class="nc" id="L392">                                                bcVote.getZxid(),</span>
<span class="nc" id="L393">                                                bcVote.getElectionEpoch(),</span>
<span class="nc" id="L394">                                                self.getPeerState(),</span>
                                                response.sid,
<span class="nc" id="L396">                                                bcVote.getPeerEpoch());</span>
                                    }
<span class="fc" id="L398">                                    sendqueue.offer(notmsg);</span>
                                }
                            }
                        }
<span class="nc" id="L402">                    } catch (InterruptedException e) {</span>
<span class="nc" id="L403">                        System.out.println(&quot;Interrupted Exception while waiting for new message&quot; +</span>
<span class="nc" id="L404">                                e.toString());</span>
<span class="pc" id="L405">                    }</span>
                }
<span class="fc" id="L407">                LOG.info(&quot;WorkerReceiver is down&quot;);</span>
<span class="fc" id="L408">            }</span>
        }


        /**
         * This worker simply dequeues a message to send and
         * and queues it on the manager's queue.
         */

        class WorkerSender extends ZooKeeperThread {
            volatile boolean stop;
            QuorumCnxManager manager;

<span class="fc" id="L421">            WorkerSender(QuorumCnxManager manager){</span>
<span class="fc" id="L422">                super(&quot;WorkerSender&quot;);</span>
<span class="fc" id="L423">                this.stop = false;</span>
<span class="fc" id="L424">                this.manager = manager;</span>
<span class="fc" id="L425">            }</span>

            public void run() {
<span class="fc bfc" id="L428" title="All 2 branches covered.">                while (!stop) {</span>
                    try {
<span class="fc" id="L430">                        ToSend m = sendqueue.poll(3000, TimeUnit.MILLISECONDS);</span>
<span class="fc bfc" id="L431" title="All 2 branches covered.">                        if(m == null) continue;</span>

<span class="fc" id="L433">                        process(m);</span>
<span class="nc" id="L434">                    } catch (InterruptedException e) {</span>
<span class="nc" id="L435">                        break;</span>
<span class="fc" id="L436">                    }</span>
                }
<span class="fc" id="L438">                LOG.info(&quot;WorkerSender is down&quot;);</span>
<span class="fc" id="L439">            }</span>

            /**
             * Called by run() once there is a new message to send.
             *
             * @param m     message to send
             */
            void process(ToSend m) {
<span class="fc" id="L447">                ByteBuffer requestBuffer = buildMsg(m.state.ordinal(), </span>
                                                        m.leader,
                                                        m.zxid, 
                                                        m.electionEpoch, 
                                                        m.peerEpoch);
<span class="fc" id="L452">                manager.toSend(m.sid, requestBuffer);</span>
<span class="fc" id="L453">            }</span>
        }

        /**
         * Test if both send and receive queues are empty.
         */
        public boolean queueEmpty() {
<span class="nc bnc" id="L460" title="All 4 branches missed.">            return (sendqueue.isEmpty() || recvqueue.isEmpty());</span>
        }


        WorkerSender ws;
        WorkerReceiver wr;

        /**
         * Constructor of class Messenger.
         *
         * @param manager   Connection manager
         */
<span class="fc" id="L472">        Messenger(QuorumCnxManager manager) {</span>

<span class="fc" id="L474">            this.ws = new WorkerSender(manager);</span>

<span class="fc" id="L476">            Thread t = new Thread(this.ws,</span>
<span class="fc" id="L477">                    &quot;WorkerSender[myid=&quot; + self.getId() + &quot;]&quot;);</span>
<span class="fc" id="L478">            t.setDaemon(true);</span>
<span class="fc" id="L479">            t.start();</span>

<span class="fc" id="L481">            this.wr = new WorkerReceiver(manager);</span>

<span class="fc" id="L483">            t = new Thread(this.wr,</span>
<span class="fc" id="L484">                    &quot;WorkerReceiver[myid=&quot; + self.getId() + &quot;]&quot;);</span>
<span class="fc" id="L485">            t.setDaemon(true);</span>
<span class="fc" id="L486">            t.start();</span>
<span class="fc" id="L487">        }</span>

        /**
         * Stops instances of WorkerSender and WorkerReceiver
         */
        void halt(){
<span class="fc" id="L493">            this.ws.stop = true;</span>
<span class="fc" id="L494">            this.wr.stop = true;</span>
<span class="fc" id="L495">        }</span>

    }

    QuorumPeer self;
    Messenger messenger;
    volatile long logicalclock; /* Election instance */
    long proposedLeader;
    long proposedZxid;
    long proposedEpoch;


    /**
     * Returns the current vlue of the logical clock counter
     */
    public long getLogicalClock(){
<span class="fc" id="L511">        return logicalclock;</span>
    }

    /**
     * Constructor of FastLeaderElection. It takes two parameters, one
     * is the QuorumPeer object that instantiated this object, and the other
     * is the connection manager. Such an object should be created only once
     * by each peer during an instance of the ZooKeeper service.
     *
     * @param self  QuorumPeer that created this object
     * @param manager   Connection manager
     */
<span class="fc" id="L523">    public FastLeaderElection(QuorumPeer self, QuorumCnxManager manager){</span>
<span class="fc" id="L524">        this.stop = false;</span>
<span class="fc" id="L525">        this.manager = manager;</span>
<span class="fc" id="L526">        starter(self, manager);</span>
<span class="fc" id="L527">    }</span>

    /**
     * This method is invoked by the constructor. Because it is a
     * part of the starting procedure of the object that must be on
     * any constructor of this class, it is probably best to keep as
     * a separate method. As we have a single constructor currently,
     * it is not strictly necessary to have it separate.
     *
     * @param self      QuorumPeer that created this object
     * @param manager   Connection manager
     */
    private void starter(QuorumPeer self, QuorumCnxManager manager) {
<span class="fc" id="L540">        this.self = self;</span>
<span class="fc" id="L541">        proposedLeader = -1;</span>
<span class="fc" id="L542">        proposedZxid = -1;</span>

<span class="fc" id="L544">        sendqueue = new LinkedBlockingQueue&lt;ToSend&gt;();</span>
<span class="fc" id="L545">        recvqueue = new LinkedBlockingQueue&lt;Notification&gt;();</span>
<span class="fc" id="L546">        this.messenger = new Messenger(manager);</span>
<span class="fc" id="L547">    }</span>

    private void leaveInstance(Vote v) {
<span class="pc bpc" id="L550" title="1 of 2 branches missed.">        if(LOG.isDebugEnabled()){</span>
<span class="nc" id="L551">            LOG.debug(&quot;About to leave FLE instance: leader=&quot;</span>
<span class="nc" id="L552">                + v.getId() + &quot;, zxid=0x&quot; +</span>
<span class="nc" id="L553">                Long.toHexString(v.getZxid()) + &quot;, my id=&quot; + self.getId()</span>
<span class="nc" id="L554">                + &quot;, my state=&quot; + self.getPeerState());</span>
        }
<span class="fc" id="L556">        recvqueue.clear();</span>
<span class="fc" id="L557">    }</span>

    public QuorumCnxManager getCnxManager(){
<span class="nc" id="L560">        return manager;</span>
    }

    volatile boolean stop;
    public void shutdown(){
<span class="fc" id="L565">        stop = true;</span>
<span class="fc" id="L566">        LOG.debug(&quot;Shutting down connection manager&quot;);</span>
<span class="fc" id="L567">        manager.halt();</span>
<span class="fc" id="L568">        LOG.debug(&quot;Shutting down messenger&quot;);</span>
<span class="fc" id="L569">        messenger.halt();</span>
<span class="fc" id="L570">        LOG.debug(&quot;FLE is down&quot;);</span>
<span class="fc" id="L571">    }</span>


    /**
     * Send notifications to all peers upon a change in our vote
     */
    private void sendNotifications() {
<span class="fc bfc" id="L578" title="All 2 branches covered.">        for (QuorumServer server : self.getVotingView().values()) {</span>
<span class="fc" id="L579">            long sid = server.id;</span>

<span class="fc" id="L581">            ToSend notmsg = new ToSend(ToSend.mType.notification,</span>
                    proposedLeader,
                    proposedZxid,
                    logicalclock,
                    QuorumPeer.ServerState.LOOKING,
                    sid,
                    proposedEpoch);
<span class="pc bpc" id="L588" title="1 of 2 branches missed.">            if(LOG.isDebugEnabled()){</span>
<span class="nc" id="L589">                LOG.debug(&quot;Sending Notification: &quot; + proposedLeader + &quot; (n.leader), 0x&quot;  +</span>
<span class="nc" id="L590">                      Long.toHexString(proposedZxid) + &quot; (n.zxid), 0x&quot; + Long.toHexString(logicalclock)  +</span>
<span class="nc" id="L591">                      &quot; (n.round), &quot; + sid + &quot; (recipient), &quot; + self.getId() +</span>
<span class="nc" id="L592">                      &quot; (myid), 0x&quot; + Long.toHexString(proposedEpoch) + &quot; (n.peerEpoch)&quot;);</span>
            }
<span class="fc" id="L594">            sendqueue.offer(notmsg);</span>
<span class="fc" id="L595">        }</span>
<span class="fc" id="L596">    }</span>


    private void printNotification(Notification n){
<span class="fc" id="L600">        LOG.info(&quot;Notification: &quot; + n.toString()</span>
<span class="fc" id="L601">                + self.getPeerState() + &quot; (my state)&quot;);</span>
<span class="fc" id="L602">    }</span>

    /**
     * Check if a pair (server id, zxid) succeeds our
     * current vote.
     *
     * @param id    Server identifier
     * @param zxid  Last zxid observed by the issuer of this vote
     */
    protected boolean totalOrderPredicate(long newId, long newZxid, long newEpoch, long curId, long curZxid, long curEpoch) {
<span class="fc" id="L612">        LOG.debug(&quot;id: &quot; + newId + &quot;, proposed id: &quot; + curId + &quot;, zxid: 0x&quot; +</span>
<span class="fc" id="L613">                Long.toHexString(newZxid) + &quot;, proposed zxid: 0x&quot; + Long.toHexString(curZxid));</span>
<span class="fc bfc" id="L614" title="All 2 branches covered.">        if(self.getQuorumVerifier().getWeight(newId) == 0){</span>
<span class="fc" id="L615">            return false;</span>
        }
        
        /*
         * We return true if one of the following three cases hold:
         * 1- New epoch is higher
         * 2- New epoch is the same as current epoch, but new zxid is higher
         * 3- New epoch is the same as current epoch, new zxid is the same
         *  as current zxid, but server id is higher.
         */
        
<span class="fc bfc" id="L626" title="All 10 branches covered.">        return ((newEpoch &gt; curEpoch) || </span>
                ((newEpoch == curEpoch) &amp;&amp;
                ((newZxid &gt; curZxid) || ((newZxid == curZxid) &amp;&amp; (newId &gt; curId)))));
    }

    /**
     * Termination predicate. Given a set of votes, determines if
     * have sufficient to declare the end of the election round.
     *
     *  @param votes    Set of votes
     *  @param l        Identifier of the vote received last
     *  @param zxid     zxid of the the vote received last
     */
    protected boolean termPredicate(
            HashMap&lt;Long, Vote&gt; votes,
            Vote vote) {

<span class="fc" id="L643">        HashSet&lt;Long&gt; set = new HashSet&lt;Long&gt;();</span>

        /*
         * First make the views consistent. Sometimes peers will have
         * different zxids for a server depending on timing.
         */
<span class="fc bfc" id="L649" title="All 2 branches covered.">        for (Map.Entry&lt;Long,Vote&gt; entry : votes.entrySet()) {</span>
<span class="fc bfc" id="L650" title="All 2 branches covered.">            if (vote.equals(entry.getValue())){</span>
<span class="fc" id="L651">                set.add(entry.getKey());</span>
            }
<span class="fc" id="L653">        }</span>

<span class="fc" id="L655">        return self.getQuorumVerifier().containsQuorum(set);</span>
    }

    /**
     * In the case there is a leader elected, and a quorum supporting
     * this leader, we have to check if the leader has voted and acked
     * that it is leading. We need this check to avoid that peers keep
     * electing over and over a peer that has crashed and it is no
     * longer leading.
     *
     * @param votes set of votes
     * @param   leader  leader id
     * @param   electionEpoch   epoch id
     */
    protected boolean checkLeader(
            HashMap&lt;Long, Vote&gt; votes,
            long leader,
            long electionEpoch){

<span class="fc" id="L674">        boolean predicate = true;</span>

        /*
         * If everyone else thinks I'm the leader, I must be the leader.
         * The other two checks are just for the case in which I'm not the
         * leader. If I'm not the leader and I haven't received a message
         * from leader stating that it is leading, then predicate is false.
         */

<span class="fc bfc" id="L683" title="All 2 branches covered.">        if(leader != self.getId()){</span>
<span class="fc bfc" id="L684" title="All 2 branches covered.">            if(votes.get(leader) == null) predicate = false;</span>
<span class="pc bpc" id="L685" title="1 of 2 branches missed.">            else if(votes.get(leader).getState() != ServerState.LEADING) predicate = false;</span>
<span class="fc bfc" id="L686" title="All 2 branches covered.">        } else if(logicalclock != electionEpoch) {</span>
<span class="fc" id="L687">            predicate = false;</span>
        } 

<span class="fc" id="L690">        return predicate;</span>
    }
    
    /**
     * This predicate checks that a leader has been elected. It doesn't
     * make a lot of sense without context (check lookForLeader) and it
     * has been separated for testing purposes.
     * 
     * @param recv  map of received votes 
     * @param ooe   map containing out of election votes (LEADING or FOLLOWING)
     * @param n     Notification
     * @return          
     */
    protected boolean ooePredicate(HashMap&lt;Long,Vote&gt; recv, 
                                    HashMap&lt;Long,Vote&gt; ooe, 
                                    Notification n) {
        
<span class="fc bfc" id="L707" title="All 2 branches covered.">        return (termPredicate(recv, new Vote(n.version, </span>
                                             n.leader,
                                             n.zxid, 
                                             n.electionEpoch, 
                                             n.peerEpoch, 
                                             n.state))
<span class="fc bfc" id="L713" title="All 2 branches covered.">                &amp;&amp; checkLeader(ooe, n.leader, n.electionEpoch));</span>
        
    }

    synchronized void updateProposal(long leader, long zxid, long epoch){
<span class="pc bpc" id="L718" title="1 of 2 branches missed.">        if(LOG.isDebugEnabled()){</span>
<span class="nc" id="L719">            LOG.debug(&quot;Updating proposal: &quot; + leader + &quot; (newleader), 0x&quot;</span>
<span class="nc" id="L720">                    + Long.toHexString(zxid) + &quot; (newzxid), &quot; + proposedLeader</span>
<span class="nc" id="L721">                    + &quot; (oldleader), 0x&quot; + Long.toHexString(proposedZxid) + &quot; (oldzxid)&quot;);</span>
        }
<span class="fc" id="L723">        proposedLeader = leader;</span>
<span class="fc" id="L724">        proposedZxid = zxid;</span>
<span class="fc" id="L725">        proposedEpoch = epoch;</span>
<span class="fc" id="L726">    }</span>

    synchronized Vote getVote(){
<span class="fc" id="L729">        return new Vote(proposedLeader, proposedZxid, proposedEpoch);</span>
    }

    /**
     * A learning state can be either FOLLOWING or OBSERVING.
     * This method simply decides which one depending on the
     * role of the server.
     *
     * @return ServerState
     */
    private ServerState learningState(){
<span class="fc bfc" id="L740" title="All 2 branches covered.">        if(self.getLearnerType() == LearnerType.PARTICIPANT){</span>
<span class="fc" id="L741">            LOG.debug(&quot;I'm a participant: &quot; + self.getId());</span>
<span class="fc" id="L742">            return ServerState.FOLLOWING;</span>
        }
        else{
<span class="fc" id="L745">            LOG.debug(&quot;I'm an observer: &quot; + self.getId());</span>
<span class="fc" id="L746">            return ServerState.OBSERVING;</span>
        }
    }

    /**
     * Returns the initial vote value of server identifier.
     *
     * @return long
     */
    private long getInitId(){
<span class="fc bfc" id="L756" title="All 2 branches covered.">        if(self.getLearnerType() == LearnerType.PARTICIPANT)</span>
<span class="fc" id="L757">            return self.getId();</span>
<span class="fc" id="L758">        else return Long.MIN_VALUE;</span>
    }

    /**
     * Returns initial last logged zxid.
     *
     * @return long
     */
    private long getInitLastLoggedZxid(){
<span class="fc bfc" id="L767" title="All 2 branches covered.">        if(self.getLearnerType() == LearnerType.PARTICIPANT)</span>
<span class="fc" id="L768">            return self.getLastLoggedZxid();</span>
<span class="fc" id="L769">        else return Long.MIN_VALUE;</span>
    }

    /**
     * Returns the initial vote value of the peer epoch.
     *
     * @return long
     */
    private long getPeerEpoch(){
<span class="fc bfc" id="L778" title="All 2 branches covered.">        if(self.getLearnerType() == LearnerType.PARTICIPANT)</span>
        	try {
<span class="fc" id="L780">        		return self.getCurrentEpoch();</span>
<span class="nc" id="L781">        	} catch(IOException e) {</span>
<span class="nc" id="L782">        		RuntimeException re = new RuntimeException(e.getMessage());</span>
<span class="nc" id="L783">        		re.setStackTrace(e.getStackTrace());</span>
<span class="nc" id="L784">        		throw re;</span>
        	}
<span class="fc" id="L786">        else return Long.MIN_VALUE;</span>
    }
    
    /**
     * Starts a new round of leader election. Whenever our QuorumPeer
     * changes its state to LOOKING, this method is invoked, and it
     * sends notifications to all other peers.
     */
    public Vote lookForLeader() throws InterruptedException {
        try {
<span class="fc" id="L796">            self.jmxLeaderElectionBean = new LeaderElectionBean();</span>
<span class="fc" id="L797">            MBeanRegistry.getInstance().register(</span>
                    self.jmxLeaderElectionBean, self.jmxLocalPeerBean);
<span class="fc" id="L799">        } catch (Exception e) {</span>
<span class="fc" id="L800">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L801">            self.jmxLeaderElectionBean = null;</span>
<span class="fc" id="L802">        }</span>
<span class="fc bfc" id="L803" title="All 2 branches covered.">        if (self.start_fle == 0) {</span>
<span class="fc" id="L804">           self.start_fle = System.currentTimeMillis();</span>
        }
        try {
<span class="fc" id="L807">            HashMap&lt;Long, Vote&gt; recvset = new HashMap&lt;Long, Vote&gt;();</span>

<span class="fc" id="L809">            HashMap&lt;Long, Vote&gt; outofelection = new HashMap&lt;Long, Vote&gt;();</span>

<span class="fc" id="L811">            int notTimeout = finalizeWait;</span>

<span class="fc" id="L813">            synchronized(this){</span>
<span class="fc" id="L814">                logicalclock++;</span>
<span class="fc" id="L815">                updateProposal(getInitId(), getInitLastLoggedZxid(), getPeerEpoch());</span>
<span class="pc" id="L816">            }</span>

<span class="fc" id="L818">            LOG.info(&quot;New election. My id =  &quot; + self.getId() +</span>
<span class="fc" id="L819">                    &quot;, proposed zxid=0x&quot; + Long.toHexString(proposedZxid));</span>
<span class="fc" id="L820">            sendNotifications();</span>

            /*
             * Loop in which we exchange notifications until we find a leader
             */

<span class="pc bpc" id="L826" title="1 of 4 branches missed.">            while ((self.getPeerState() == ServerState.LOOKING) &amp;&amp;</span>
                    (!stop)){
                /*
                 * Remove next notification from queue, times out after 2 times
                 * the termination time
                 */
<span class="fc" id="L832">                Notification n = recvqueue.poll(notTimeout,</span>
                        TimeUnit.MILLISECONDS);

                /*
                 * Sends more notifications if haven't received enough.
                 * Otherwise processes new notification.
                 */
<span class="fc bfc" id="L839" title="All 2 branches covered.">                if(n == null){</span>
<span class="fc bfc" id="L840" title="All 2 branches covered.">                    if(manager.haveDelivered()){</span>
<span class="fc" id="L841">                        sendNotifications();</span>
                    } else {
<span class="fc" id="L843">                        manager.connectAll();</span>
                    }

                    /*
                     * Exponential backoff
                     */
<span class="fc" id="L849">                    int tmpTimeOut = notTimeout*2;</span>
<span class="pc bpc" id="L850" title="1 of 2 branches missed.">                    notTimeout = (tmpTimeOut &lt; maxNotificationInterval?</span>
                            tmpTimeOut : maxNotificationInterval);
<span class="fc" id="L852">                    LOG.info(&quot;Notification time out: &quot; + notTimeout);</span>
<span class="fc" id="L853">                }</span>
<span class="pc bpc" id="L854" title="1 of 2 branches missed.">                else if(self.getVotingView().containsKey(n.sid)) {</span>
                    /*
                     * Only proceed if the vote comes from a replica in the
                     * voting view.
                     */
<span class="pc bpc" id="L859" title="2 of 4 branches missed.">                    switch (n.state) {</span>
                    case LOOKING:
                        // If notification &gt; current, replace and send messages out
<span class="fc bfc" id="L862" title="All 2 branches covered.">                        if (n.electionEpoch &gt; logicalclock) {</span>
<span class="fc" id="L863">                            logicalclock = n.electionEpoch;</span>
<span class="fc" id="L864">                            recvset.clear();</span>
<span class="fc bfc" id="L865" title="All 2 branches covered.">                            if(totalOrderPredicate(n.leader, n.zxid, n.peerEpoch,</span>
<span class="fc" id="L866">                                    getInitId(), getInitLastLoggedZxid(), getPeerEpoch())) {</span>
<span class="fc" id="L867">                                updateProposal(n.leader, n.zxid, n.peerEpoch);</span>
                            } else {
<span class="fc" id="L869">                                updateProposal(getInitId(),</span>
<span class="fc" id="L870">                                        getInitLastLoggedZxid(),</span>
<span class="fc" id="L871">                                        getPeerEpoch());</span>
                            }
<span class="fc" id="L873">                            sendNotifications();</span>
<span class="fc bfc" id="L874" title="All 2 branches covered.">                        } else if (n.electionEpoch &lt; logicalclock) {</span>
<span class="pc bpc" id="L875" title="1 of 2 branches missed.">                            if(LOG.isDebugEnabled()){</span>
<span class="nc" id="L876">                                LOG.debug(&quot;Notification election epoch is smaller than logicalclock. n.electionEpoch = 0x&quot;</span>
<span class="nc" id="L877">                                        + Long.toHexString(n.electionEpoch)</span>
<span class="nc" id="L878">                                        + &quot;, logicalclock=0x&quot; + Long.toHexString(logicalclock));</span>
                            }
                            break;
<span class="fc bfc" id="L881" title="All 2 branches covered.">                        } else if (totalOrderPredicate(n.leader, n.zxid, n.peerEpoch,</span>
                                proposedLeader, proposedZxid, proposedEpoch)) {
<span class="fc" id="L883">                            updateProposal(n.leader, n.zxid, n.peerEpoch);</span>
<span class="fc" id="L884">                            sendNotifications();</span>
                        }

<span class="pc bpc" id="L887" title="1 of 2 branches missed.">                        if(LOG.isDebugEnabled()){</span>
<span class="nc" id="L888">                            LOG.debug(&quot;Adding vote: from=&quot; + n.sid +</span>
                                    &quot;, proposed leader=&quot; + n.leader +
<span class="nc" id="L890">                                    &quot;, proposed zxid=0x&quot; + Long.toHexString(n.zxid) +</span>
<span class="nc" id="L891">                                    &quot;, proposed election epoch=0x&quot; + Long.toHexString(n.electionEpoch));</span>
                        }

<span class="fc" id="L894">                        recvset.put(n.sid, new Vote(n.leader, n.zxid, n.electionEpoch, n.peerEpoch));</span>

<span class="fc bfc" id="L896" title="All 2 branches covered.">                        if (termPredicate(recvset,</span>
                                new Vote(proposedLeader, proposedZxid,
                                        logicalclock, proposedEpoch))) {

                            // Verify if there is any change in the proposed leader
<span class="fc bfc" id="L901" title="All 2 branches covered.">                            while((n = recvqueue.poll(finalizeWait,</span>
                                    TimeUnit.MILLISECONDS)) != null){
<span class="fc bfc" id="L903" title="All 2 branches covered.">                                if(totalOrderPredicate(n.leader, n.zxid, n.peerEpoch,</span>
                                        proposedLeader, proposedZxid, proposedEpoch)){
<span class="fc" id="L905">                                    recvqueue.put(n);</span>
<span class="fc" id="L906">                                    break;</span>
                                }
                            }

                            /*
                             * This predicate is true once we don't read any new
                             * relevant message from the reception queue
                             */
<span class="fc bfc" id="L914" title="All 2 branches covered.">                            if (n == null) {</span>
<span class="fc bfc" id="L915" title="All 2 branches covered.">                                self.setPeerState((proposedLeader == self.getId()) ?</span>
<span class="fc" id="L916">                                        ServerState.LEADING: learningState());</span>

<span class="fc" id="L918">                                Vote endVote = new Vote(proposedLeader,</span>
                                                        proposedZxid,
                                                        logicalclock,
                                                        proposedEpoch);
<span class="fc" id="L922">                                leaveInstance(endVote);</span>
<span class="fc" id="L923">                                return endVote;</span>
                            }
                        }
                        break;
                    case OBSERVING:
<span class="nc" id="L928">                        LOG.debug(&quot;Notification from observer: &quot; + n.sid);</span>
<span class="nc" id="L929">                        break;</span>
                    case FOLLOWING:
                    case LEADING:
                        /*
                         * Consider all notifications from the same epoch
                         * together.
                         */
<span class="fc bfc" id="L936" title="All 2 branches covered.">                        if(n.electionEpoch == logicalclock){</span>
<span class="fc" id="L937">                            recvset.put(n.sid, new Vote(n.leader,</span>
                                                          n.zxid,
                                                          n.electionEpoch,
                                                          n.peerEpoch));
                           
<span class="fc bfc" id="L942" title="All 2 branches covered.">                            if(ooePredicate(recvset, outofelection, n)) {</span>
<span class="fc bfc" id="L943" title="All 2 branches covered.">                                self.setPeerState((n.leader == self.getId()) ?</span>
<span class="fc" id="L944">                                        ServerState.LEADING: learningState());</span>

<span class="fc" id="L946">                                Vote endVote = new Vote(n.leader, </span>
                                        n.zxid, 
                                        n.electionEpoch, 
                                        n.peerEpoch);
<span class="fc" id="L950">                                leaveInstance(endVote);</span>
<span class="fc" id="L951">                                return endVote;</span>
                            }
                        }

                        /*
                         * Before joining an established ensemble, verify
                         * a majority is following the same leader.
                         */
<span class="fc" id="L959">                        outofelection.put(n.sid, new Vote(n.version,</span>
                                                            n.leader,
                                                            n.zxid,
                                                            n.electionEpoch,
                                                            n.peerEpoch,
                                                            n.state));
           
<span class="fc bfc" id="L966" title="All 2 branches covered.">                        if(ooePredicate(outofelection, outofelection, n)) {</span>
<span class="fc" id="L967">                            synchronized(this){</span>
<span class="fc" id="L968">                                logicalclock = n.electionEpoch;</span>
<span class="pc bpc" id="L969" title="1 of 2 branches missed.">                                self.setPeerState((n.leader == self.getId()) ?</span>
<span class="fc" id="L970">                                        ServerState.LEADING: learningState());</span>
<span class="pc" id="L971">                            }</span>
<span class="fc" id="L972">                            Vote endVote = new Vote(n.leader,</span>
                                                    n.zxid,
                                                    n.electionEpoch,
                                                    n.peerEpoch);
<span class="fc" id="L976">                            leaveInstance(endVote);</span>
<span class="fc" id="L977">                            return endVote;</span>
                        }
                        break;
                    default:
<span class="nc" id="L981">                        LOG.warn(&quot;Notification state unrecognized: {} (n.state), {} (n.sid)&quot;,</span>
<span class="nc" id="L982">                                n.state, n.sid);</span>
<span class="nc" id="L983">                        break;</span>
                    }
                } else {
<span class="nc" id="L986">                    LOG.warn(&quot;Ignoring notification from non-cluster member &quot; + n.sid);</span>
                }
<span class="fc" id="L988">            }</span>
<span class="fc" id="L989">            return null;</span>
        } finally {
<span class="fc" id="L991">            try {</span>
<span class="pc bpc" id="L992" title="2 of 10 branches missed.">                if(self.jmxLeaderElectionBean != null){</span>
<span class="fc" id="L993">                    MBeanRegistry.getInstance().unregister(</span>
                            self.jmxLeaderElectionBean);
                }
<span class="nc" id="L996">            } catch (Exception e) {</span>
<span class="nc" id="L997">                LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L998">            }</span>
<span class="fc" id="L999">            self.jmxLeaderElectionBean = null;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>